gpio: rcar: Fix runtime PM imbalance on error
[linux/fpc-iii.git] / tools / testing / selftests / efivarfs / efivarfs.sh
bloba90f394f9aa90c45c15c4a2c83d742421b9c187a
1 #!/bin/bash
2 # SPDX-License-Identifier: GPL-2.0
4 efivarfs_mount=/sys/firmware/efi/efivars
5 test_guid=210be57c-9849-4fc7-a635-e6382d1aec27
7 # Kselftest framework requirement - SKIP code is 4.
8 ksft_skip=4
10 file_cleanup()
12 chattr -i $1
13 rm -f $1
16 check_prereqs()
18 local msg="skip all tests:"
20 if [ $UID != 0 ]; then
21 echo $msg must be run as root >&2
22 exit $ksft_skip
25 if ! grep -q "^\S\+ $efivarfs_mount efivarfs" /proc/mounts; then
26 echo $msg efivarfs is not mounted on $efivarfs_mount >&2
27 exit $ksft_skip
31 run_test()
33 local test="$1"
35 echo "--------------------"
36 echo "running $test"
37 echo "--------------------"
39 if [ "$(type -t $test)" = 'function' ]; then
40 ( $test )
41 else
42 ( ./$test )
45 if [ $? -ne 0 ]; then
46 echo " [FAIL]"
47 rc=1
48 else
49 echo " [PASS]"
53 test_create()
55 local attrs='\x07\x00\x00\x00'
56 local file=$efivarfs_mount/$FUNCNAME-$test_guid
58 printf "$attrs\x00" > $file
60 if [ ! -e $file ]; then
61 echo "$file couldn't be created" >&2
62 exit 1
65 if [ $(stat -c %s $file) -ne 5 ]; then
66 echo "$file has invalid size" >&2
67 file_cleanup $file
68 exit 1
70 file_cleanup $file
73 test_create_empty()
75 local file=$efivarfs_mount/$FUNCNAME-$test_guid
77 : > $file
79 if [ ! -e $file ]; then
80 echo "$file can not be created without writing" >&2
81 exit 1
83 file_cleanup $file
86 test_create_read()
88 local file=$efivarfs_mount/$FUNCNAME-$test_guid
89 ./create-read $file
90 file_cleanup $file
93 test_delete()
95 local attrs='\x07\x00\x00\x00'
96 local file=$efivarfs_mount/$FUNCNAME-$test_guid
98 printf "$attrs\x00" > $file
100 if [ ! -e $file ]; then
101 echo "$file couldn't be created" >&2
102 exit 1
105 file_cleanup $file
107 if [ -e $file ]; then
108 echo "$file couldn't be deleted" >&2
109 exit 1
114 # test that we can remove a variable by issuing a write with only
115 # attributes specified
116 test_zero_size_delete()
118 local attrs='\x07\x00\x00\x00'
119 local file=$efivarfs_mount/$FUNCNAME-$test_guid
121 printf "$attrs\x00" > $file
123 if [ ! -e $file ]; then
124 echo "$file does not exist" >&2
125 exit 1
128 chattr -i $file
129 printf "$attrs" > $file
131 if [ -e $file ]; then
132 echo "$file should have been deleted" >&2
133 exit 1
137 test_open_unlink()
139 local file=$efivarfs_mount/$FUNCNAME-$test_guid
140 ./open-unlink $file
143 # test that we can create a range of filenames
144 test_valid_filenames()
146 local attrs='\x07\x00\x00\x00'
147 local ret=0
149 local file_list="abc dump-type0-11-1-1362436005 1234 -"
150 for f in $file_list; do
151 local file=$efivarfs_mount/$f-$test_guid
153 printf "$attrs\x00" > $file
155 if [ ! -e $file ]; then
156 echo "$file could not be created" >&2
157 ret=1
158 else
159 file_cleanup $file
161 done
163 exit $ret
166 test_invalid_filenames()
168 local attrs='\x07\x00\x00\x00'
169 local ret=0
171 local file_list="
172 -1234-1234-1234-123456789abc
174 foo-bar
175 -foo-
176 foo-barbazba-foob-foob-foob-foobarbazfoo
177 foo-------------------------------------
178 -12345678-1234-1234-1234-123456789abc
179 a-12345678=1234-1234-1234-123456789abc
180 a-12345678-1234=1234-1234-123456789abc
181 a-12345678-1234-1234=1234-123456789abc
182 a-12345678-1234-1234-1234=123456789abc
183 1112345678-1234-1234-1234-123456789abc"
185 for f in $file_list; do
186 local file=$efivarfs_mount/$f
188 printf "$attrs\x00" 2>/dev/null > $file
190 if [ -e $file ]; then
191 echo "Creating $file should have failed" >&2
192 file_cleanup $file
193 ret=1
195 done
197 exit $ret
200 check_prereqs
202 rc=0
204 run_test test_create
205 run_test test_create_empty
206 run_test test_create_read
207 run_test test_delete
208 run_test test_zero_size_delete
209 run_test test_open_unlink
210 run_test test_valid_filenames
211 run_test test_invalid_filenames
213 exit $rc